题目
给定一个字符串 s
和一个字符串数组
words
。 words
中所有字符串
长度相同。
s
中的 串联子串 是指一个包含
words
中所有字符串以任意顺序排列连接起来的子串。
- 例如,如果
words = ["ab","cd","ef"]
, 那么
"abcdef"
, "abefcd"
,"cdabef"
,
"cdefab"
,"efabcd"
, 和 "efcdab"
都是串联子串。 "acdbef"
不是串联子串,因为他不是任何
words
排列的连接。
返回所有串联子串在 s
中的开始索引。你可以以
任意顺序 返回答案。
示例 1:
1 2 3 4 5 6
| 输入:s = "barfoothefoobarman", words = ["foo","bar"] 输出:[0,9] 解释:因为 words.length == 2 同时 words[i].length == 3,连接的子字符串的长度必须为 6。 子串 "barfoo" 开始位置是 0。它是 words 中以 ["bar","foo"] 顺序排列的连接。 子串 "foobar" 开始位置是 9。它是 words 中以 ["foo","bar"] 顺序排列的连接。 输出顺序无关紧要。返回 [9,0] 也是可以的。
|
示例 2:
1 2 3 4 5
| 输入:s = "wordgoodgoodgoodbestword", words = ["word","good","best","word"] 输出:[] 解释:因为 words.length == 4 并且 words[i].length == 4,所以串联子串的长度必须为 16。 s 中没有子串长度为 16 并且等于 words 的任何顺序排列的连接。 所以我们返回一个空数组。
|
示例 3:
1 2 3 4 5 6
| 输入:s = "barfoofoobarthefoobarman", words = ["bar","foo","the"] 输出:[6,9,12] 解释:因为 words.length == 3 并且 words[i].length == 3,所以串联子串的长度必须为 9。 子串 "foobarthe" 开始位置是 6。它是 words 中以 ["foo","bar","the"] 顺序排列的连接。 子串 "barthefoo" 开始位置是 9。它是 words 中以 ["bar","the","foo"] 顺序排列的连接。 子串 "thefoobar" 开始位置是 12。它是 words 中以 ["the","foo","bar"] 顺序排列的连接。
|
提示:
1 <= s.length <= 104
1 <= words.length <= 5000
1 <= words[i].length <= 30
words[i]
和 s
由小写英文字母组成
题解
我的思路跟佬的解法其实是一致的,但是没有选择走下去,因为感觉写不出来,orz想直接跳过难题了(我的思路和朴素哈希表的思路是一致的)
30.
串联所有单词的子串 - 力扣(LeetCode)
- 用一个哈希表map储存每个word及其出现的次数,单词个数为
m
,单词长度为w
- 遍历
s
,当前位置i
为起点,子串sub
长度为w * m
- 然后我们统计单词出现次数是否是正确的,如果正确就继续往后找直到sub末尾,然后记录到
ans
中;
- 如果出现没有出现或者次数超过的单词,可以直接剪枝了
事实上,我们可以优化这个枚举起点的过程。
我们可以将起点根据 当前下标与单词长度的取余结果
进行分类,这样我们就不用频繁的建立新的哈希表和进行单词统计。
对于取余结果相同的位置,我们可以运用「滑动窗口」来进行词频统计,复杂度为O(n)
,当处理完所有余数情况时,代表我们枚举完了所有的起点。
1 2 3 4 5 6 7 8 9 10 11 12 13 14 15 16 17 18 19 20 21 22 23 24 25 26 27 28 29
| class Solution { public List<Integer> findSubstring(String s, String[] words) { int n = s.length(), m = words.length, w = words[0].length(); Map<String, Integer> map = new HashMap<>(); for (String str : words) map.put(str, map.getOrDefault(str, 0) + 1); List<Integer> ans = new ArrayList<>(); for (int i = 0; i < w; i++) { Map<String, Integer> temp = new HashMap<>(); for (int j = i; j + w <= n; j += w) { String cur = s.substring(j, j + w); temp.put(cur, temp.getOrDefault(cur, 0) + 1); if (j >= i + (m * w)) { int idx = j - m * w; String prev = s.substring(idx, idx + w); if (temp.get(prev) == 1) temp.remove(prev); else temp.put(prev, temp.get(prev) - 1); if (!temp.getOrDefault(prev, 0).equals(map.getOrDefault(prev, 0))) continue; } if (!temp.getOrDefault(cur, 0).equals(map.getOrDefault(cur, 0))) continue; if (temp.equals(map)) ans.add(j - (m - 1) * w); } } return ans; } }
|